"""
All wgpu structs.
"""

# THIS CODE IS AUTOGENERATED - DO NOT EDIT


# %% Structs (45)

RequestAdapterOptions = {"power_preference": "GPUPowerPreference"}

DeviceDescriptor = {
    "label": "str",
    "extensions": "GPUExtensionName-list",
    "limits": "GPULimits",
}

Limits = {
    "max_bind_groups": "GPUSize32",
    "max_dynamic_uniform_buffers_per_pipeline_layout": "GPUSize32",
    "max_dynamic_storage_buffers_per_pipeline_layout": "GPUSize32",
    "max_sampled_textures_per_shader_stage": "GPUSize32",
    "max_samplers_per_shader_stage": "GPUSize32",
    "max_storage_buffers_per_shader_stage": "GPUSize32",
    "max_storage_textures_per_shader_stage": "GPUSize32",
    "max_uniform_buffers_per_shader_stage": "GPUSize32",
    "max_uniform_buffer_binding_size": "GPUSize32",
}

BufferDescriptor = {
    "label": "str",
    "size": "int",
    "usage": "GPUBufferUsageFlags",
    "mapped_at_creation": "bool",
}

TextureDescriptor = {
    "label": "str",
    "size": "GPUExtent3D",
    "mip_level_count": "GPUIntegerCoordinate",
    "sample_count": "GPUSize32",
    "dimension": "GPUTextureDimension",
    "format": "GPUTextureFormat",
    "usage": "GPUTextureUsageFlags",
}

TextureViewDescriptor = {
    "label": "str",
    "format": "GPUTextureFormat",
    "dimension": "GPUTextureViewDimension",
    "aspect": "GPUTextureAspect",
    "base_mip_level": "GPUIntegerCoordinate",
    "mip_level_count": "GPUIntegerCoordinate",
    "base_array_layer": "GPUIntegerCoordinate",
    "array_layer_count": "GPUIntegerCoordinate",
}

SamplerDescriptor = {
    "label": "str",
    "address_mode_u": "GPUAddressMode",
    "address_mode_v": "GPUAddressMode",
    "address_mode_w": "GPUAddressMode",
    "mag_filter": "GPUFilterMode",
    "min_filter": "GPUFilterMode",
    "mipmap_filter": "GPUFilterMode",
    "lod_min_clamp": "float",
    "lod_max_clamp": "float",
    "compare": "GPUCompareFunction",
}

BindGroupLayoutDescriptor = {"label": "str", "entries": "GPUBindGroupLayoutEntry-list"}

BindGroupLayoutEntry = {
    "binding": "GPUIndex32",
    "visibility": "GPUShaderStageFlags",
    "type": "GPUBindingType",
    "has_dynamic_offset": "bool",
    "min_buffer_binding_size": "int",
    "view_dimension": "GPUTextureViewDimension",
    "texture_component_type": "GPUTextureComponentType",
    "multisampled": "bool",
    "storage_texture_format": "GPUTextureFormat",
}

BindGroupDescriptor = {
    "label": "str",
    "layout": "GPUBindGroupLayout",
    "entries": "GPUBindGroupEntry-list",
}

BindGroupEntry = {"binding": "GPUIndex32", "resource": "GPUBindingResource"}

BufferBinding = {"buffer": "GPUBuffer", "offset": "int", "size": "int"}

PipelineLayoutDescriptor = {
    "label": "str",
    "bind_group_layouts": "GPUBindGroupLayout-list",
}

ShaderModuleDescriptor = {"label": "str", "code": "str", "source_map": "dict"}

ProgrammableStageDescriptor = {"module": "GPUShaderModule", "entry_point": "str"}

ComputePipelineDescriptor = {
    "label": "str",
    "layout": "GPUPipelineLayout",
    "compute_stage": "GPUProgrammableStageDescriptor",
}

RenderPipelineDescriptor = {
    "label": "str",
    "layout": "GPUPipelineLayout",
    "vertex_stage": "GPUProgrammableStageDescriptor",
    "fragment_stage": "GPUProgrammableStageDescriptor",
    "primitive_topology": "GPUPrimitiveTopology",
    "rasterization_state": "GPURasterizationStateDescriptor",
    "color_states": "GPUColorStateDescriptor-list",
    "depth_stencil_state": "GPUDepthStencilStateDescriptor",
    "vertex_state": "GPUVertexStateDescriptor",
    "sample_count": "GPUSize32",
    "sample_mask": "GPUSampleMask",
    "alpha_to_coverage_enabled": "bool",
}

RasterizationStateDescriptor = {
    "front_face": "GPUFrontFace",
    "cull_mode": "GPUCullMode",
    "depth_bias": "GPUDepthBias",
    "depth_bias_slope_scale": "float",
    "depth_bias_clamp": "float",
}

ColorStateDescriptor = {
    "format": "GPUTextureFormat",
    "alpha_blend": "GPUBlendDescriptor",
    "color_blend": "GPUBlendDescriptor",
    "write_mask": "GPUColorWriteFlags",
}

BlendDescriptor = {
    "src_factor": "GPUBlendFactor",
    "dst_factor": "GPUBlendFactor",
    "operation": "GPUBlendOperation",
}

DepthStencilStateDescriptor = {
    "format": "GPUTextureFormat",
    "depth_write_enabled": "bool",
    "depth_compare": "GPUCompareFunction",
    "stencil_front": "GPUStencilStateFaceDescriptor",
    "stencil_back": "GPUStencilStateFaceDescriptor",
    "stencil_read_mask": "GPUStencilValue",
    "stencil_write_mask": "GPUStencilValue",
}

StencilStateFaceDescriptor = {
    "compare": "GPUCompareFunction",
    "fail_op": "GPUStencilOperation",
    "depth_fail_op": "GPUStencilOperation",
    "pass_op": "GPUStencilOperation",
}

VertexStateDescriptor = {
    "index_format": "GPUIndexFormat",
    "vertex_buffers": "GPUVertexBufferLayoutDescriptor?-list",
}

VertexBufferLayoutDescriptor = {
    "array_stride": "int",
    "step_mode": "GPUInputStepMode",
    "attributes": "GPUVertexAttributeDescriptor-list",
}

VertexAttributeDescriptor = {
    "format": "GPUVertexFormat",
    "offset": "int",
    "shader_location": "GPUIndex32",
}

CommandBufferDescriptor = {"label": "str"}

CommandEncoderDescriptor = {"label": "str"}

TextureDataLayout = {
    "offset": "int",
    "bytes_per_row": "GPUSize32",
    "rows_per_image": "GPUSize32",
}

BufferCopyView = {
    "offset": "int",
    "bytes_per_row": "GPUSize32",
    "rows_per_image": "GPUSize32",
    "buffer": "GPUBuffer",
}

TextureCopyView = {
    "texture": "GPUTexture",
    "mip_level": "GPUIntegerCoordinate",
    "origin": "GPUOrigin3D",
}

ImageBitmapCopyView = {"image_bitmap": "array", "origin": "GPUOrigin2D"}

ComputePassDescriptor = {"label": "str"}

RenderPassDescriptor = {
    "label": "str",
    "color_attachments": "GPURenderPassColorAttachmentDescriptor-list",
    "depth_stencil_attachment": "GPURenderPassDepthStencilAttachmentDescriptor",
    "occlusion_query_set": "GPUQuerySet",
}

RenderPassColorAttachmentDescriptor = {
    "attachment": "GPUTextureView",
    "resolve_target": "GPUTextureView",
    "load_value": "GPULoadOp-or-GPUColor",
    "store_op": "GPUStoreOp",
}

RenderPassDepthStencilAttachmentDescriptor = {
    "attachment": "GPUTextureView",
    "depth_load_value": "GPULoadOp-or-float",
    "depth_store_op": "GPUStoreOp",
    "depth_read_only": "bool",
    "stencil_load_value": "GPULoadOp-or-GPUStencilValue",
    "stencil_store_op": "GPUStoreOp",
    "stencil_read_only": "bool",
}

RenderBundleDescriptor = {"label": "str"}

RenderBundleEncoderDescriptor = {
    "label": "str",
    "color_formats": "GPUTextureFormat-list",
    "depth_stencil_format": "GPUTextureFormat",
    "sample_count": "GPUSize32",
}

FenceDescriptor = {"label": "str", "initial_value": "GPUFenceValue"}

QuerySetDescriptor = {
    "label": "str",
    "type": "GPUQueryType",
    "count": "GPUSize32",
    "pipeline_statistics": "GPUPipelineStatisticName-list",
}

SwapChainDescriptor = {
    "label": "str",
    "device": "GPUDevice",
    "format": "GPUTextureFormat",
    "usage": "GPUTextureUsageFlags",
}

UncapturedErrorEventInit = {"error": "GPUError"}

Color = {"r": "float", "g": "float", "b": "float", "a": "float"}

Origin2D = {"x": "GPUIntegerCoordinate", "y": "GPUIntegerCoordinate"}

Origin3D = {
    "x": "GPUIntegerCoordinate",
    "y": "GPUIntegerCoordinate",
    "z": "GPUIntegerCoordinate",
}

Extent3D = {
    "width": "GPUIntegerCoordinate",
    "height": "GPUIntegerCoordinate",
    "depth": "GPUIntegerCoordinate",
}
